module TalltyImportExport
  module Attr
    class ExportHeaderItem
      include AttrJson::Model
      attr_json_config(bad_cast: :as_nil, unknown_key: :allow)

      attr_json :key, :string
      attr_json :name, :string
      attr_json :attr_type, :string
      attr_json :format, :string
      attr_json :method, :string
      attr_json :chain, :string, array: true
      attr_json :merge, :boolean
      attr_json :json, :string
      attr_json :select, ActiveModel::Type::Value.new, array: true
      attr_json :source, :boolean
      attr_json :proc, ActiveModel::Type::Value.new, array: true
      attr_json :children, self.to_type, array: true

      def depth
        children&.count.to_i + 1
      end

      # 取叶子结点，获取到excel表格的宽度
      def leaves
        if children.present?
          children.flat_map do |child|
            child.leaves
          end
        else
          [self]
        end
      end
    end

    class ExportHeader
      include AttrJson::Model
      attr_json_config(bad_cast: :as_nil, unknown_key: :allow)

      attr_json :items, ExportHeaderItem.to_type, array: true

      def depth
        items.map(&:depth).max
      end

      # def height payload
      #   items.map do |item|
      #     TalltyImportExport::ExportPayload.new(header: item, payload: payload[item.key])
      #   end.map do |export_payload|
      #     export_payload.height
      #   end.max
      # end
    end
  end
end
